[Mongo Portable](../README.md) > [BinaryParser](../classes/binaryparser.md)

# Class: BinaryParser

## Hierarchy

**BinaryParser**

## Index

### Constructors

* [constructor](binaryparser.md#constructor)

### Properties

* [allowExceptions](binaryparser.md#allowexceptions)
* [bigEndian](binaryparser.md#bigendian)
* [logger](binaryparser.md#logger)

### Methods

* [decodeFloat](binaryparser.md#decodefloat)
* [decodeInt](binaryparser.md#decodeint)
* [decode_utf8](binaryparser.md#decode_utf8)
* [encodeFloat](binaryparser.md#encodefloat)
* [encodeInt](binaryparser.md#encodeint)
* [encode_cstring](binaryparser.md#encode_cstring)
* [encode_int32](binaryparser.md#encode_int32)
* [encode_int64](binaryparser.md#encode_int64)
* [encode_utf8](binaryparser.md#encode_utf8)
* [fromByte](binaryparser.md#frombyte)
* [fromDWord](binaryparser.md#fromdword)
* [fromDouble](binaryparser.md#fromdouble)
* [fromFloat](binaryparser.md#fromfloat)
* [fromInt](binaryparser.md#fromint)
* [fromLong](binaryparser.md#fromlong)
* [fromQWord](binaryparser.md#fromqword)
* [fromShort](binaryparser.md#fromshort)
* [fromSmall](binaryparser.md#fromsmall)
* [fromWord](binaryparser.md#fromword)
* [generate12string](binaryparser.md#generate12string)
* [hlprint](binaryparser.md#hlprint)
* [hprint](binaryparser.md#hprint)
* [ilprint](binaryparser.md#ilprint)
* [toByte](binaryparser.md#tobyte)
* [toDWord](binaryparser.md#todword)
* [toDouble](binaryparser.md#todouble)
* [toFloat](binaryparser.md#tofloat)
* [toInt](binaryparser.md#toint)
* [toLong](binaryparser.md#tolong)
* [toQWord](binaryparser.md#toqword)
* [toShort](binaryparser.md#toshort)
* [toSmall](binaryparser.md#tosmall)
* [toWord](binaryparser.md#toword)
* [decode_utf8](binaryparser.md#decode_utf8-1)
* [encode_cstring](binaryparser.md#encode_cstring-1)
* [encode_int32](binaryparser.md#encode_int32-1)
* [encode_int64](binaryparser.md#encode_int64-1)
* [encode_utf8](binaryparser.md#encode_utf8-1)
* [fromByte](binaryparser.md#frombyte-1)
* [fromDWord](binaryparser.md#fromdword-1)
* [fromDouble](binaryparser.md#fromdouble-1)
* [fromFloat](binaryparser.md#fromfloat-1)
* [fromInt](binaryparser.md#fromint-1)
* [fromLong](binaryparser.md#fromlong-1)
* [fromQWord](binaryparser.md#fromqword-1)
* [fromShort](binaryparser.md#fromshort-1)
* [fromSmall](binaryparser.md#fromsmall-1)
* [fromWord](binaryparser.md#fromword-1)
* [hlprint](binaryparser.md#hlprint-1)
* [hprint](binaryparser.md#hprint-1)
* [ilprint](binaryparser.md#ilprint-1)
* [toByte](binaryparser.md#tobyte-1)
* [toDWord](binaryparser.md#todword-1)
* [toDouble](binaryparser.md#todouble-1)
* [toFloat](binaryparser.md#tofloat-1)
* [toInt](binaryparser.md#toint-1)
* [toLong](binaryparser.md#tolong-1)
* [toQWord](binaryparser.md#toqword-1)
* [toShort](binaryparser.md#toshort-1)
* [toSmall](binaryparser.md#tosmall-1)
* [toWord](binaryparser.md#toword-1)

---

## Constructors

<a id="constructor"></a>

###  constructor

⊕ **new BinaryParser**(bigEndian?: *`boolean`*, allowExceptions?: *`boolean`*): [BinaryParser](binaryparser.md)

*Defined in [binary/BinaryParser.ts:20](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L20)*

**Parameters:**

| Param | Type | Default value |
| ------ | ------ | ------ |
| `Default value` bigEndian | `boolean` | false |
| `Default value` allowExceptions | `boolean` | true |

**Returns:** [BinaryParser](binaryparser.md)

___

## Properties

<a id="allowexceptions"></a>

### `<Private>` allowExceptions

**● allowExceptions**: *`boolean`*

*Defined in [binary/BinaryParser.ts:20](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L20)*

___
<a id="bigendian"></a>

### `<Private>` bigEndian

**● bigEndian**: *`boolean`*

*Defined in [binary/BinaryParser.ts:19](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L19)*

___
<a id="logger"></a>

### `<Protected>` logger

**● logger**: *`JSWLogger`*

*Defined in [binary/BinaryParser.ts:17](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L17)*

___

## Methods

<a id="decodefloat"></a>

###  decodeFloat

▸ **decodeFloat**(data: * `string` &#124; `number`*, precisionBits: *`number`*, exponentBits: *`number`*): `number`

*Defined in [binary/BinaryParser.ts:43](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L43)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `string` &#124; `number`|
| precisionBits | `number` |
| exponentBits | `number` |

**Returns:** `number`

___
<a id="decodeint"></a>

###  decodeInt

▸ **decodeInt**(data: * `string` &#124; `number`*, bits: *`number`*, signed: *`boolean`*, forceBigEndian?: *`boolean`*): `number`

*Defined in [binary/BinaryParser.ts:150](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L150)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `string` &#124; `number`|
| bits | `number` |
| signed | `boolean` |
| `Optional` forceBigEndian | `boolean` |

**Returns:** `number`

___
<a id="decode_utf8"></a>

###  decode_utf8

▸ **decode_utf8**(binaryStr: *`string`*): `string`

*Defined in [binary/BinaryParser.ts:524](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L524)*

UTF8 methods

**Parameters:**

| Param | Type |
| ------ | ------ |
| binaryStr | `string` |

**Returns:** `string`

___
<a id="encodefloat"></a>

###  encodeFloat

▸ **encodeFloat**(data: *`number`*, precisionBits: *`number`*, exponentBits: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:168](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L168)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |
| precisionBits | `number` |
| exponentBits | `number` |

**Returns:** `string`

___
<a id="encodeint"></a>

###  encodeInt

▸ **encodeInt**(data: *`number`*, bits: *`number`*, signed: *`boolean`*, forceBigEndian?: *`boolean`*): `string`

*Defined in [binary/BinaryParser.ts:385](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L385)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |
| bits | `number` |
| signed | `boolean` |
| `Optional` forceBigEndian | `boolean` |

**Returns:** `string`

___
<a id="encode_cstring"></a>

###  encode_cstring

▸ **encode_cstring**(s: * `string` &#124; `number`*): `string`

*Defined in [binary/BinaryParser.ts:558](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L558)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| s |  `string` &#124; `number`|

**Returns:** `string`

___
<a id="encode_int32"></a>

###  encode_int32

▸ **encode_int32**(num: *`number`*, asArray?: *`boolean`*):  `string`[] &#124; `string`

*Defined in [binary/BinaryParser.ts:459](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L459)*

**Parameters:**

| Param | Type | Default value |
| ------ | ------ | ------ |
| num | `number` | - |
| `Default value` asArray | `boolean` | false |

**Returns:**  `string`[] &#124; `string`

___
<a id="encode_int64"></a>

###  encode_int64

▸ **encode_int64**(num: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:481](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L481)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| num | `number` |

**Returns:** `string`

___
<a id="encode_utf8"></a>

###  encode_utf8

▸ **encode_utf8**(s: *`string`*): `string`

*Defined in [binary/BinaryParser.ts:564](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L564)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| s | `string` |

**Returns:** `string`

___
<a id="frombyte"></a>

###  fromByte

▸ **fromByte**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:440](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L440)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromdword"></a>

###  fromDWord

▸ **fromDWord**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:450](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L450)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromdouble"></a>

###  fromDouble

▸ **fromDouble**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:456](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L456)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromfloat"></a>

###  fromFloat

▸ **fromFloat**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:454](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L454)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromint"></a>

###  fromInt

▸ **fromInt**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:446](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L446)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromlong"></a>

###  fromLong

▸ **fromLong**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:448](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L448)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromqword"></a>

###  fromQWord

▸ **fromQWord**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:452](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L452)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromshort"></a>

###  fromShort

▸ **fromShort**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:442](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L442)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromsmall"></a>

###  fromSmall

▸ **fromSmall**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:438](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L438)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromword"></a>

###  fromWord

▸ **fromWord**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:444](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L444)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="generate12string"></a>

###  generate12string

▸ **generate12string**(): `string`

*Defined in [binary/BinaryParser.ts:36](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L36)*

Generate a 12 byte id string used in ObjectId"s
*__method__*: BinaryParser#generate12string

**Returns:** `string`
The 12 byte id binary string.

___
<a id="hlprint"></a>

###  hlprint

▸ **hlprint**(s: *`string`*): `number`

*Defined in [binary/BinaryParser.ts:626](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L626)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| s | `string` |

**Returns:** `number`

___
<a id="hprint"></a>

###  hprint

▸ **hprint**(s: *`string`*): `number`

*Defined in [binary/BinaryParser.ts:586](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L586)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| s | `string` |

**Returns:** `number`

___
<a id="ilprint"></a>

###  ilprint

▸ **ilprint**(s: *`string`*): `number`

*Defined in [binary/BinaryParser.ts:606](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L606)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| s | `string` |

**Returns:** `number`

___
<a id="tobyte"></a>

###  toByte

▸ **toByte**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:439](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L439)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="todword"></a>

###  toDWord

▸ **toDWord**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:449](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L449)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="todouble"></a>

###  toDouble

▸ **toDouble**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:455](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L455)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="tofloat"></a>

###  toFloat

▸ **toFloat**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:453](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L453)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="toint"></a>

###  toInt

▸ **toInt**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:445](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L445)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="tolong"></a>

###  toLong

▸ **toLong**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:447](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L447)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="toqword"></a>

###  toQWord

▸ **toQWord**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:451](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L451)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="toshort"></a>

###  toShort

▸ **toShort**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:441](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L441)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="tosmall"></a>

###  toSmall

▸ **toSmall**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:437](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L437)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="toword"></a>

###  toWord

▸ **toWord**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:443](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L443)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="decode_utf8-1"></a>

### `<Static>` decode_utf8

▸ **decode_utf8**(binaryStr: *`string`*): `string`

*Defined in [binary/BinaryParser.ts:670](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L670)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| binaryStr | `string` |

**Returns:** `string`

___
<a id="encode_cstring-1"></a>

### `<Static>` encode_cstring

▸ **encode_cstring**(s: * `string` &#124; `number`*): `string`

*Defined in [binary/BinaryParser.ts:671](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L671)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| s |  `string` &#124; `number`|

**Returns:** `string`

___
<a id="encode_int32-1"></a>

### `<Static>` encode_int32

▸ **encode_int32**(num: *`number`*, asArray?: *`boolean`*):  `string`[] &#124; `string`

*Defined in [binary/BinaryParser.ts:668](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L668)*

**Parameters:**

| Param | Type | Default value |
| ------ | ------ | ------ |
| num | `number` | - |
| `Default value` asArray | `boolean` | false |

**Returns:**  `string`[] &#124; `string`

___
<a id="encode_int64-1"></a>

### `<Static>` encode_int64

▸ **encode_int64**(num: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:669](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L669)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| num | `number` |

**Returns:** `string`

___
<a id="encode_utf8-1"></a>

### `<Static>` encode_utf8

▸ **encode_utf8**(s: *`string`*): `string`

*Defined in [binary/BinaryParser.ts:672](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L672)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| s | `string` |

**Returns:** `string`

___
<a id="frombyte-1"></a>

### `<Static>` fromByte

▸ **fromByte**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:650](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L650)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromdword-1"></a>

### `<Static>` fromDWord

▸ **fromDWord**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:660](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L660)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromdouble-1"></a>

### `<Static>` fromDouble

▸ **fromDouble**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:666](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L666)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromfloat-1"></a>

### `<Static>` fromFloat

▸ **fromFloat**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:664](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L664)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromint-1"></a>

### `<Static>` fromInt

▸ **fromInt**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:656](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L656)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromlong-1"></a>

### `<Static>` fromLong

▸ **fromLong**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:658](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L658)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromqword-1"></a>

### `<Static>` fromQWord

▸ **fromQWord**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:662](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L662)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromshort-1"></a>

### `<Static>` fromShort

▸ **fromShort**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:652](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L652)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromsmall-1"></a>

### `<Static>` fromSmall

▸ **fromSmall**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:648](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L648)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="fromword-1"></a>

### `<Static>` fromWord

▸ **fromWord**(data: *`number`*): `string`

*Defined in [binary/BinaryParser.ts:654](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L654)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data | `number` |

**Returns:** `string`

___
<a id="hlprint-1"></a>

### `<Static>` hlprint

▸ **hlprint**(s: *`string`*): `number`

*Defined in [binary/BinaryParser.ts:675](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L675)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| s | `string` |

**Returns:** `number`

___
<a id="hprint-1"></a>

### `<Static>` hprint

▸ **hprint**(s: *`string`*): `number`

*Defined in [binary/BinaryParser.ts:673](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L673)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| s | `string` |

**Returns:** `number`

___
<a id="ilprint-1"></a>

### `<Static>` ilprint

▸ **ilprint**(s: *`string`*): `number`

*Defined in [binary/BinaryParser.ts:674](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L674)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| s | `string` |

**Returns:** `number`

___
<a id="tobyte-1"></a>

### `<Static>` toByte

▸ **toByte**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:649](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L649)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="todword-1"></a>

### `<Static>` toDWord

▸ **toDWord**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:659](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L659)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="todouble-1"></a>

### `<Static>` toDouble

▸ **toDouble**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:665](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L665)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="tofloat-1"></a>

### `<Static>` toFloat

▸ **toFloat**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:663](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L663)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="toint-1"></a>

### `<Static>` toInt

▸ **toInt**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:655](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L655)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="tolong-1"></a>

### `<Static>` toLong

▸ **toLong**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:657](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L657)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="toqword-1"></a>

### `<Static>` toQWord

▸ **toQWord**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:661](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L661)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="toshort-1"></a>

### `<Static>` toShort

▸ **toShort**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:651](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L651)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="tosmall-1"></a>

### `<Static>` toSmall

▸ **toSmall**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:647](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L647)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___
<a id="toword-1"></a>

### `<Static>` toWord

▸ **toWord**(data: * `number` &#124; `string`*): `number`

*Defined in [binary/BinaryParser.ts:653](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/binary/BinaryParser.ts#L653)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| data |  `number` &#124; `string`|

**Returns:** `number`

___

