[Mongo Portable](../README.md) > [ConnectionHelper](../classes/connectionhelper.md)

# Class: ConnectionHelper

## Hierarchy

**ConnectionHelper**

## Index

### Constructors

* [constructor](connectionhelper.md#constructor)

### Properties

* [_pool](connectionhelper.md#_pool)

### Methods

* [addConnection](connectionhelper.md#addconnection)
* [dropConnection](connectionhelper.md#dropconnection)
* [getConnection](connectionhelper.md#getconnection)
* [hasConnection](connectionhelper.md#hasconnection)
* [validateDatabaseName](connectionhelper.md#validatedatabasename)

---

## Constructors

<a id="constructor"></a>

###  constructor

⊕ **new ConnectionHelper**(): [ConnectionHelper](connectionhelper.md)

*Defined in [utils/ConnectionHelper.ts:14](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/utils/ConnectionHelper.ts#L14)*

**Returns:** [ConnectionHelper](connectionhelper.md)

___

## Properties

<a id="_pool"></a>

### `<Private>` _pool

**● _pool**: *[IConnection](../interfaces/iconnection.md)[]* =  []

*Defined in [utils/ConnectionHelper.ts:14](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/utils/ConnectionHelper.ts#L14)*

___

## Methods

<a id="addconnection"></a>

###  addConnection

▸ **addConnection**(name: *`string`*, id: *`any`*, instance: *[MongoPortable](mongoportable.md)*): `void`

*Defined in [utils/ConnectionHelper.ts:20](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/utils/ConnectionHelper.ts#L20)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| name | `string` |
| id | `any` |
| instance | [MongoPortable](mongoportable.md) |

**Returns:** `void`

___
<a id="dropconnection"></a>

###  dropConnection

▸ **dropConnection**(name: *`string`*): `boolean`

*Defined in [utils/ConnectionHelper.ts:41](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/utils/ConnectionHelper.ts#L41)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| name | `string` |

**Returns:** `boolean`

___
<a id="getconnection"></a>

###  getConnection

▸ **getConnection**(name: *`string`*): [IConnection](../interfaces/iconnection.md)

*Defined in [utils/ConnectionHelper.ts:31](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/utils/ConnectionHelper.ts#L31)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| name | `string` |

**Returns:** [IConnection](../interfaces/iconnection.md)

___
<a id="hasconnection"></a>

###  hasConnection

▸ **hasConnection**(name: *`string`*): `boolean`

*Defined in [utils/ConnectionHelper.ts:53](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/utils/ConnectionHelper.ts#L53)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| name | `string` |

**Returns:** `boolean`

___
<a id="validatedatabasename"></a>

### `<Private>` validateDatabaseName

▸ **validateDatabaseName**(name: *`string`*): `boolean`

*Defined in [utils/ConnectionHelper.ts:73](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/utils/ConnectionHelper.ts#L73)*

Validates the database name
*__method__*: MongoPortable#_validateDatabaseName

**Parameters:**

| Param | Type |
| ------ | ------ |
| name | `string` |

**Returns:** `boolean`
"true" if the name is valid

___

