[Mongo Portable](../README.md) > [IAbstractStore](../interfaces/iabstractstore.md)

# Interface: IAbstractStore

## Hierarchy

**IAbstractStore**

## Implemented by

* [BaseStore](../classes/basestore.md)

## Index

### Methods

* [all](iabstractstore.md#all)
* [backup](iabstractstore.md#backup)
* [backups](iabstractstore.md#backups)
* [createCollection](iabstractstore.md#createcollection)
* [ensureIndex](iabstractstore.md#ensureindex)
* [find](iabstractstore.md#find)
* [findOne](iabstractstore.md#findone)
* [insert](iabstractstore.md#insert)
* [remove](iabstractstore.md#remove)
* [removeBackup](iabstractstore.md#removebackup)
* [restore](iabstractstore.md#restore)
* [save](iabstractstore.md#save)
* [update](iabstractstore.md#update)

---

## Methods

<a id="all"></a>

###  all

▸ **all**(event: *`any`*):  `any` &#124; `Promise`<`any`>

*Defined in [store/IAbstractStore.ts:10](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L10)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `any` &#124; `Promise`<`any`>

___
<a id="backup"></a>

###  backup

▸ **backup**(event: *`any`*):  `any` &#124; `Promise`<`any`>

*Defined in [store/IAbstractStore.ts:22](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L22)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `any` &#124; `Promise`<`any`>

___
<a id="backups"></a>

###  backups

▸ **backups**(event: *`any`*):  `any` &#124; `Promise`<`any`>

*Defined in [store/IAbstractStore.ts:24](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L24)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `any` &#124; `Promise`<`any`>

___
<a id="createcollection"></a>

###  createCollection

▸ **createCollection**(event: *`any`*):  `boolean` &#124; `Promise`<`boolean`>

*Defined in [store/IAbstractStore.ts:4](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L4)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `boolean` &#124; `Promise`<`boolean`>

___
<a id="ensureindex"></a>

###  ensureIndex

▸ **ensureIndex**(event: *`any`*):  `any` &#124; `Promise`<`any`>

*Defined in [store/IAbstractStore.ts:20](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L20)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `any` &#124; `Promise`<`any`>

___
<a id="find"></a>

###  find

▸ **find**(event: *`any`*):  `any` &#124; `Promise`<`any`>

*Defined in [store/IAbstractStore.ts:12](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L12)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `any` &#124; `Promise`<`any`>

___
<a id="findone"></a>

###  findOne

▸ **findOne**(event: *`any`*):  `any` &#124; `Promise`<`any`>

*Defined in [store/IAbstractStore.ts:14](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L14)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `any` &#124; `Promise`<`any`>

___
<a id="insert"></a>

###  insert

▸ **insert**(event: *`any`*):  `boolean` &#124; `Promise`<`boolean`>

*Defined in [store/IAbstractStore.ts:6](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L6)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `boolean` &#124; `Promise`<`boolean`>

___
<a id="remove"></a>

###  remove

▸ **remove**(event: *`any`*):  `boolean` &#124; `Promise`<`boolean`>

*Defined in [store/IAbstractStore.ts:18](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L18)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `boolean` &#124; `Promise`<`boolean`>

___
<a id="removebackup"></a>

###  removeBackup

▸ **removeBackup**(event: *`any`*):  `any` &#124; `Promise`<`any`>

*Defined in [store/IAbstractStore.ts:26](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L26)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `any` &#124; `Promise`<`any`>

___
<a id="restore"></a>

###  restore

▸ **restore**(event: *`any`*):  `any` &#124; `Promise`<`any`>

*Defined in [store/IAbstractStore.ts:28](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L28)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `any` &#124; `Promise`<`any`>

___
<a id="save"></a>

###  save

▸ **save**(event: *`any`*):  `any` &#124; `Promise`<`any`>

*Defined in [store/IAbstractStore.ts:8](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L8)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `any` &#124; `Promise`<`any`>

___
<a id="update"></a>

###  update

▸ **update**(event: *`any`*):  `boolean` &#124; `Promise`<`boolean`>

*Defined in [store/IAbstractStore.ts:16](https://github.com/EastolfiWebDev/MongoPortable/blob/d5d3826/src/store/IAbstractStore.ts#L16)*

**Parameters:**

| Param | Type |
| ------ | ------ |
| event | `any` |

**Returns:**  `boolean` &#124; `Promise`<`boolean`>

___

